<?php
/**
 * @package SJ Cool Loading
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2013 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com MD
 */

defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

class plgSystemPlg_sj_cool_loading extends JPlugin
{
	protected $app = array();
	protected $_params = null;

	function __construct($subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
		$this->app = JFactory::getApplication();
		$this->_params = $this->params;

	}

	function onBeforeRender()
	{
		if ($this->app->isAdmin()) return;
		$app = JFactory::getApplication();
		$document = JFactory::getDocument();
		$document->addStyleSheet( JURI::root(true) . '/plugins/system/plg_sj_cool_loading/assets/css/animate.css');
		if ($app->isSite()) {
			if (( int )$this->params->get('include_jquery', '1')) {
				$document->addScript(JURI::root(true) . '/plugins/system/plg_sj_cool_loading/assets/js/jquery-1.8.2.min.js');
				$document->addScript(JURI::root(true) . '/plugins/system/plg_sj_cool_loading/assets/js/jquery-noconflict.js');
			}
		}
		return true;
	}

	public function onAfterRender()
	{
		if ($this->app->isAdmin()) return;
		$app = JFactory::getApplication();
		$body = JResponse::GetBody();
		if ($app->isSite()) {
			$_cls = $this->_params->get('plg_name_class');
			if(empty($_cls)) return;
			$array_styles_wow = array("animated","bounce","flash","pulse","shake","swing","tada","wobble","bounceIn","bounceInDown","bounceInLeft","bounceInRight","bounceInUp","fadeIn","fadeInDown","fadeInDownBig","fadeInLeft","fadeInLeftBig","fadeInRight","fadeInRightBig","fadeInUp","fadeInUpBig","flip","flipInX","flipInY","rotateIn","rotateInDownLeft","rotateInDownRight","rotateInUpLeft","rotateInUpRight","slideInDown","slideInLeft","slideInRight","rubberBand","lightSpeedIn","hinge","rollIn");
			$array_cls_wow = explode(',',$_cls);
			$send = '';
			foreach($array_cls_wow as $index => $class){
				if($send == ''){
					$send = $class . '---';
				}else{
					$send = $send . '!@#$%^&*()' . $class . '---';
				}
				foreach($array_styles_wow as $style){
					$items_style =  $this->_params->get('plg_style_not_ie_'.$style);
					if($items_style == NULL)continue;
					$data_items = explode('-',$items_style);
					foreach($data_items as $data_item){
						$array_index = explode(':',$data_item);
						if($index == ($array_index[0]-1)){
							$items = explode(',',$array_index[1]);
							foreach($items as $item){
								$send = $send . $item . '-' . $style .'@';
							}
						}
					}
				}
			}
			$_style = $this->_params->get('plg_type_class');
			$body = str_replace('</body>', $this->_addScriptQV($send,$_style) . '</body>', $body);
			JResponse::setBody($body);
			return true;
		}
	}

	function onAfterDispatch(){
	
	}
	
	protected function _addScriptQV($send,$_style)
	{
		ob_start();
		?>
		
		<script type="text/javascript">
			//<![CDATA[
				var data = '<?php echo $send;?>';
				var style = '<?php echo $_style; ?>';
				
					var array_cls = data.split('!@#$%^&*()');
					<?php if($this->_params->get('plg_repeart') == 0){?>
						var after = 'holdAnimClass';
					<?php }else{ ?>
						var after = 'removeAnim';
					<?php } ?>
					for(var i = 0; i < array_cls.length; i++){
						var items_cls = array_cls[i].split('---');
						var cls = items_cls[0];
						var items = items_cls[1].split('@');
						if(style != 'none'){
							jQuery(cls).attr('data-anijs','if: scroll, on: window, do: '+style+' animated, before: scrollReveal, after: '+after);
						}
						for(a = 0; a < items.length; a++){
							var index = items[a].split('-');
							if(parseInt(index[0]) == 0){continue;}
							if(index[0] != 'all'){
								jQuery(cls).eq(parseInt(index[0]) - 1).attr('data-anijs','if: scroll, on: window, do: '+index[1]+' animated, before: scrollReveal, after: '+after);
							}else{
								jQuery(cls).attr('data-anijs','if: scroll, on: window, do: '+index[1]+' animated, before: scrollReveal, after: '+after);
							}
						}
					}
				
			//]]>
		</script>
		<script src="<?php echo JURI::root(true);?>/plugins/system/plg_sj_cool_loading/assets/js/anijs.js"></script>
		<script src="<?php echo JURI::root(true);?>/plugins/system/plg_sj_cool_loading/assets/js/anijs-helper-scrollreveal.js"></script>
		<?php
		$jq = ob_get_contents();
		ob_end_clean();
		return $jq;
	}
}
